package com.gyee.edge.gateway.bridge.rocketmq.producter;


import com.gyee.edge.gateway.bridge.test.ReadGolden;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.client.producer.DefaultMQProducer;
import org.apache.rocketmq.client.producer.SendCallback;
import org.apache.rocketmq.client.producer.SendResult;
import org.apache.rocketmq.common.message.Message;

//异步请求
@Slf4j
public class AsyncProducter {
    public static void dataSendProducter() throws Exception {
        //实例化消息的生产者
        DefaultMQProducer producer = new DefaultMQProducer("group_test");
        //设置nameServer的地址
        producer.setNamesrvAddr("127.0.0.1:9876");
        //启动producer实例
        producer.start();
        byte[] bytes = ReadGolden.protoData();
            //创建消息
            Message message = new Message("keyMessage"/*Topic*/,
                    "TagA"/* Tag*/, "OrderID888", bytes);
            producer.send(message, new SendCallback() {
                @Override
                public void onSuccess(SendResult sendResult) {
                    System.out.println(sendResult);
                }

                @Override
                public void onException(Throwable throwable) {
                    log.info("消息发送失败", throwable);
                    throwable.printStackTrace();
                }
            });
//            Thread.sleep(1000);
//        producer.shutdown();
    }
}
