package com.gyee.edge.gateway.protobuf;

import com.google.protobuf.InvalidProtocolBufferException;
import com.google.protobuf.MessageOrBuilder;
import com.google.protobuf.TextFormat;
import lombok.extern.slf4j.Slf4j;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Slf4j
public class UserProtoTest {
//    public static void main(String[] args) {
//        UserProto.User.Builder user = UserProto.User.newBuilder();
//        System.out.println("测试两千个点数据:");
//        Map<String,Double> map = new HashMap<>();
//        for(int i = 1;i<=2000;i++){
//            map.put(i+"",Math.random());
//        }
//        user.putAllMap(map);
//        Date ST=new Date();
//        UserProto.User build1 = user.build();
//        byte[] s1 = build1.toByteArray();
//        Date ET=new Date();
//        System.out.println("序列化时间："+(ET.getTime()-ST.getTime()));
//        System.out.println("protobuf序列化大小: " + s1.length);
//        UserProto.User user1 = null;
//        try {
//            //反序列化
//            Date date1 = new Date();
//            user1 = UserProto.User.parseFrom(s1);
//            Date date2 = new Date();
//            System.out.println("反序列化时间"+(date2.getTime()-date1.getTime()));
//        } catch (InvalidProtocolBufferException e) {
//            e.printStackTrace();
//        }
//
//        System.out.println("--------------------");
//
//        System.out.println("测试两千个点一半数据空值测试:");
//        user.clear();
//        map.clear();
//        for(int j = 1;j<=2000;j++){
//            if (j<=1000){
//                map.put(j+"",Math.random());
//            }else {
//                map.put(j+"",null);
//            }
//        }
//        user.putAllMap(map);
//        Date ST1=new Date();
//        UserProto.User build2 = user.build();
//        byte[] s2 = build2.toByteArray();
//        Date ET2=new Date();
//        System.out.println("序列化时间："+(ET2.getTime()-ST1.getTime()));
//        System.out.println("protobuf一半数据空值序列化大小: " + s2.length);
//        UserProto.User users2 = null;
//        try {
//            //反序列化
//            Date date3 = new Date();
//            users2 = UserProto.User.parseFrom(s2);
//            Date date4 = new Date();
//            System.out.println("反序列化时间"+(date4.getTime()-date3.getTime()));
//        } catch (InvalidProtocolBufferException e) {
//            e.printStackTrace();
//        }
//    }

    /**
     * 处理反序列化时中文出现的八进制问题（属性值为中文时可能会出现这样的八进制\346\223\215\344\275\234\345\221\230）
     * 可直接使用 protobuf 自带的 TextFormat.printToUnicodeString(message) 方法，但是这个方法过时了，直接从这个方法内部拿出来使用就可以了
     *
     * @param message 转换的 protobuf 对象
     * @return string
     */
    public static String printToUnicodeString(MessageOrBuilder message) {
        return TextFormat.printer().escapingNonAscii(false).printToString(message);
    }

}
