package com.gyee.edge.loader.service;


import com.gyee.edge.loader.data.TsData;
import com.gyee.edge.loader.data.TsPointData;
import feign.Headers;
import feign.Param;
import feign.RequestLine;

import java.util.List;
import java.util.Map;

public interface WriteDataService {

    @Headers({"Content-Type: application/json","Accept: application/json"})
    @RequestLine("POST /latest/batch")
    void saveTspointDatas(List<TsPointData> tsDataList);


    @RequestLine("GET /latest?keys={keys}")
    Map<String, TsData> getData(@Param(value = "keys")String tagName);
}
